use serde::{Deserialize, Serialize};

#[derive(Debug, Clone, PartialEq, Eq, Serialize, Deserialize)]
pub struct MyRequest {
    pub key: [u8; 32],
    pub body: Vec<u8>,
    pub sig: Vec<u8>, // FIXME :: fixed length array not supported by serde [u8; 64],
}

#[derive(Debug, Clone, PartialEq, Eq, Serialize, Deserialize)]
pub enum MyResult {
    Okay(MyResponse),
    Fail(i64),
}

#[derive(Debug, Clone, PartialEq, Eq, Serialize, Deserialize)]
pub struct MyResponse {
    // sig: [u8; 64],
    pub sig: Vec<u8>, // FIXME :: fixed length array not supported by serde [u8; 64],
}

// type TestnetMagic = i64;
//
// pub enum NetworkId {
//     Mainnet,
//     Testnet(TestnetMagic),
// }
//
// type Version = i64;
//
// type Blake2b224Hash = [u8; 24];
// type ScriptHash = Blake2b224Hash;
//
// type TokenName = Vec<u8>;
// type Currency = (ScriptHash, TokenName);
//
// pub struct Init {
//     version: Version,
//     network_id: NetworkId,
//     currencies: Vec<Currency>,
//     routing: bool,
//     htlc: bool,
// }
//
// type Positive = i64;
// type Natural = i64;
// type Amount = Natural;
// type Markdown = String;
// type Milliseconds = Natural;
//
// type ChannelId = Vec<u8>;
//
// // type ChannelMessage<msg> = (ChannelId, msg)
//
// type VerificationKey = [u8; 32];
//
// pub struct Open {
//     currency: Currency,
//     funding_amount: Amount,
//     gift_amount: Amount,
//     respond_period: Milliseconds,
//     minimum_depth: Positive,
//     max_htlc_amount: Amount,
//     max_total_htlc_amount: Amount,
//     max_htlc_count: Positive,
//     verification_key: VerificationKey,
// }
//
// pub struct Accept {
//     respond_period: Milliseconds,
//     minimum_depth: Positive,
//     min_htlc_amount: Amount,
//     max_htlc_amount: Amount,
//     max_total_htlc_amount: Amount,
//     max_htlc_count: Positive,
//     verification_key: VerificationKey,
// }
